// COFF  IAT(Import Address Table)  EAT(Export Address Table) ̃T[`֌W̊֐
//
// Copyright (c) 2001-2002 Tomoya Tokairin

#include "dbg.h"

#define PE_HEADERSIZE 0x1000


//-----------------------------------
// IvV COFF wb_擾֐
// t@CAp

BOOL GetCoffHead(LPSTR szExeName,	// t@Cǂޏꍇ exe t@C
				 BOOL bFile,  // t@Cǂޏꍇ TRUE
				 LPSTR lpszModuleName, // ǂޏꍇAW[ԂB
				 HANDLE hProcess,	
				 DWORD dwImageBase,
				 PIMAGE_OPTIONAL_HEADER32 pCoffHead,
				 BOOL bDebug){

	FILE* f;
	BYTE headData[PE_HEADERSIZE];
	char temp[CHR_BUF];
	DWORD dwAddr,dwByte;
	
	if(bFile){ // t@C
		if(bDebug) OutputErrorMessage("fopen: %s\n",szExeName);
		if(!(f = fopen(szExeName,"rb"))){
			OutputErrorMessage("Can't open %s\n",szExeName);
			return FALSE;
		}
		fread(headData,1,PE_HEADERSIZE,f);
		fclose(f);
	}
	// 
	else if(!ReadProcessMemory(hProcess,(LPVOID)dwImageBase,(LPVOID)headData,PE_HEADERSIZE,&dwByte)) return FALSE;

	// PE wb_ʒu擾
	memcpy(&dwAddr,headData+0x3c,4);

	// PE ``FbN
	memcpy(temp,headData + dwAddr,4);
	if(strcmp(temp,"PE")) {
		OutputErrorMessage("This is not PE format file. %s\n",szExeName);
		return FALSE;
	}
	dwAddr += 4;

	// W COFF wb_̕΂
	dwAddr += 20; 

	// IvV COFF wb_擾
	memcpy(pCoffHead,headData + dwAddr,sizeof(IMAGE_OPTIONAL_HEADER32));

	// W[擾
	if(!bFile) GetModuleName(hProcess,dwImageBase,pCoffHead,temp,CHR_BUF);
	if(lpszModuleName) strcpy(lpszModuleName,temp);

	if(bDebug){
		OutputErrorMessage("\n*********\n");
		if(bFile)OutputErrorMessage("Exe file = %s\n",szExeName);
		else OutputErrorMessage("Module Name = %s\n",lpszModuleName);
		OutputErrorMessage("Image base = 0x%x\n",pCoffHead->ImageBase);
		OutputErrorMessage("Image base (real) = 0x%x\n",dwImageBase);
		OutputErrorMessage("Image size = 0x%x\n",pCoffHead->SizeOfImage);
		OutputErrorMessage("Code base = 0x%x\n",pCoffHead->BaseOfCode);
		OutputErrorMessage("Export table RVA = 0x%x\n",pCoffHead->DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress);
		OutputErrorMessage("Export table size = 0x%x\n",pCoffHead->DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].Size);
		OutputErrorMessage("Import table RVA = 0x%x\n",pCoffHead->DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress);
		OutputErrorMessage("Import table size = 0x%x\n",pCoffHead->DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].Size);
		OutputErrorMessage("IAT RVA = 0x%x\n",pCoffHead->DataDirectory[IMAGE_DIRECTORY_ENTRY_IAT].VirtualAddress);
		OutputErrorMessage("IAT SIZE = 0x%x\n",pCoffHead->DataDirectory[IMAGE_DIRECTORY_ENTRY_IAT].Size);
		OutputErrorMessage("*********\n");
	}
	
	return TRUE;
}



//-----------------------------------
// C|[ge[ũT[`֐
// dwMode = IMP_S_SHOWALLFUNCTION ̂ƂC|[g֐ impOut ɏo
// dwMode = IMP_S_BREAKALL ̎AׂĂ̊֐ break ł
// dwMode = IMP_S_FUNCTIONADDR ̎Aw肵֐̃AhXԂ

#define IMP_S_BREAKALL					0
#define IMP_S_FUNCTIONADDR				1
#define IMP_S_SHOWALLFUNCTION			2
#define IMP_S_SHOWALLFUNCTIONTOSTDOUT	3  // stdout ɕ\ꍇ

#define IMP_DIR_SIZE 16384  // C|[gfBNge[ũf[^TCY(oCgA傫K)

DWORD SearchImportTable(HANDLE hProcess,
					   DWORD dwImageBase,
						  PIMAGE_OPTIONAL_HEADER32 pCoffHead,
						  LPSTR lpszTargetFunction, 
						  DWORD dwMode,
						  BOOL bDebug
						  ){

	DWORD i,i2,dwByte,dwPreOutputMode;
	char szModuleName[CHR_BUF],szFunction[CHR_BUF];
	DWORD dwAddr;
	DWORD dwImpTableBase = pCoffHead->DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress ; 
	DWORD dwImpTableSize = pCoffHead->DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].Size-sizeof(IMAGE_IMPORT_DESCRIPTOR); // Ō̃e[u NULLȂ̂ł̂Ԃ
	DWORD dwIATBase		 = pCoffHead->DataDirectory[IMAGE_DIRECTORY_ENTRY_IAT].VirtualAddress;
	DWORD dwIATSize		 = pCoffHead->DataDirectory[IMAGE_DIRECTORY_ENTRY_IAT].Size;

	BYTE impDirData[IMP_DIR_SIZE];  // C|[gfBNge[ũf[^

	DWORD dwLookupBase;
	IMAGE_IMPORT_DESCRIPTOR imgImpDesc;
	DWORD dwFunctionAddr;
	
	if(!dwImpTableBase){
		OutputErrorMessage("\nImport Table is not included.\n");
		return 0;
	}

	if(dwImpTableSize > IMP_DIR_SIZE){
		OutputErrorMessage("\nerror: dwImpTableSize(= %d) > %d\n",dwImpTableSize,IMP_DIR_SIZE);
		return 0;
	}

	if(bDebug){
		GetModuleName(hProcess,dwImageBase,pCoffHead,szModuleName,CHR_BUF);
		OutputErrorMessage("\n---------------------------\n");
		OutputErrorMessage("Information of Import Table of %s\n",szModuleName);
		OutputErrorMessage("Image Base = 0x%x\n",dwImageBase);
		OutputErrorMessage("Import table Base(RVA) = 0x%x\n",dwImpTableBase);
		OutputErrorMessage("Import table size = %d byte\n",dwImpTableSize);
		OutputErrorMessage("IAT Base(RVA) = 0x%x\n",dwIATBase);
		OutputErrorMessage("IAT size = %d byte\n",dwIATSize);
		OutputErrorMessage("---------------------------\n\n");
	}

	dwPreOutputMode = GetCurrentOutputMode();
	if(dwMode == IMP_S_SHOWALLFUNCTIONTOSTDOUT) SetOutputMode(ERRMODE_STDOUT,NULL);

	// C|[gfBNge[uCɎ擾
	if(!ReadProcessMemory(hProcess,(LPVOID)(dwImpTableBase+dwImageBase),
		(LPVOID)impDirData,dwImpTableSize,&dwByte)) return 0;

	for(i=0; i<dwImpTableSize; i += sizeof(IMAGE_IMPORT_DESCRIPTOR)){

		//C|[g bNAbv e[uRVA擾
		memcpy(&imgImpDesc,impDirData+i,sizeof(IMAGE_IMPORT_DESCRIPTOR));
		dwLookupBase = imgImpDesc.OriginalFirstThunk;

		// W[擾
		if(!ReadProcessMemory(hProcess,
			(LPVOID)(imgImpDesc.Name+dwImageBase),(LPVOID)szModuleName,CHR_BUF,&dwByte)) return 0;

		// W[C|[g֐𒲂ׂ
		// { i2 < dwIATSize ƂƂ낾ǁA
		// ܂ dwIATSize = 0 ƂRpC
		// ݂Ȃ̂łƂ肠 8192 ƂƂB
//		for(i2 = 0; i2 < dwIATSize; i2 += sizeof(DWORD))
		for(i2 = 0; i2 < 8192; i2 += sizeof(DWORD)){
			
			// C|[g bNAbv e[u 𑖍 
			// Hint/Name Table RVA(relative virtual address) 擾
			if(!ReadProcessMemory(hProcess,(LPVOID)(dwLookupBase+i2+dwImageBase),
				(LPVOID)&dwAddr,sizeof(DWORD),&dwByte)) return 0;
			if(!dwAddr) break;
			
			// ֐擾
			dwAddr += 2;  // qg̕΂
			if(!ReadProcessMemory(hProcess,(LPVOID)(dwAddr+dwImageBase),(LPVOID)szFunction,CHR_BUF,&dwByte)) return 0;
			
			if(dwMode != IMP_S_FUNCTIONADDR || !strcmp(szFunction,lpszTargetFunction)){
				
				// ֐̃AhX擾
				dwFunctionAddr = GetDWORD(hProcess,imgImpDesc.FirstThunk+i2+dwImageBase);
				
				// ֐̃AhXԂă^[
				if(dwMode == IMP_S_FUNCTIONADDR){
					if(bDebug) OutputErrorMessage("%s = 0x%x\n",szFunction,dwFunctionAddr);
					return dwFunctionAddr;
				}
				
				// ֐ƃAhX\
				else if(dwMode == IMP_S_SHOWALLFUNCTION || dwMode == IMP_S_SHOWALLFUNCTIONTOSTDOUT){
					OutputErrorMessage("0x%8x  1  %s  %s\r\n",dwFunctionAddr,szModuleName,szFunction);
				}
				
				// u[Nł
				else if(dwMode == IMP_S_BREAKALL){
					
					if(bDebug) OutputErrorMessage("0x%8x  %s  %s\n",dwFunctionAddr,szModuleName,szFunction);
					
					if(!PushBreakatSpecifiedAddr(hProcess,dwFunctionAddr,
						MAX_ORG_CODE,szFunction,szModuleName,1)){
						OutputErrorMessage("function: %s\nmodule: %s\n\n",szFunction,szModuleName);
					}
				}
				
			}
		}
	}

	SetOutputMode(dwPreOutputMode,NULL);

	if(dwMode != IMP_S_FUNCTIONADDR) return 1;
	return 0;
}




//-----------------------------------------
// DLL  EXE t@C̃C|[gAhXe[vT[`
// w肵֐̃AhX𒲂ׂ֐
DWORD GetImpAddrOfAPI(HANDLE hProcess,
					  DWORD dwImageBase,
					  PIMAGE_OPTIONAL_HEADER32 pCoffHead,
					  LPSTR lpszTargetFunction,    // AhX𒲂ׂ֐
					  BOOL bDebug){

	DWORD dwAddr = SearchImportTable(hProcess,dwImageBase,pCoffHead,lpszTargetFunction,IMP_S_FUNCTIONADDR,bDebug);

	if(bDebug)
		OutputErrorMessage("GetImpAddrOfAPI [%s = 0x%x]\n",lpszTargetFunction,dwAddr);

	return  dwAddr;
}



//---------------------------------------------------
// DLL  EXE t@C̃C|[gAhXe[vT[`
// C|[g邷ׂĂ̊֐Ƀu[Nł֐
BOOL SetBreakToAllImportFunction(HANDLE hProcess,
					  DWORD dwImageBase,
								  PIMAGE_OPTIONAL_HEADER32 pCoffHead,
								  BOOL bDebug
								  ){
	
	return SearchImportTable(hProcess,dwImageBase,pCoffHead,"",IMP_S_BREAKALL,bDebug);
}


//-----------------------------------
// DLL  EXE t@C̃C|[gAhXe[vT[`
// C|[g֐ STDOUT ɏo͂֐
BOOL ShowImportFunctions(HANDLE hProcess,
					  DWORD dwImageBase,
					  PIMAGE_OPTIONAL_HEADER32 pCoffHead){

	return  SearchImportTable(hProcess,dwImageBase,pCoffHead,"",IMP_S_SHOWALLFUNCTIONTOSTDOUT,TRUE);
}




//-------------------------------------------------
// [h DLL ̖OGNX|[ge[u𒲂ׂĎ擾֐
BOOL GetModuleName(HANDLE hProcess,
				   DWORD dwImageBase,
					PIMAGE_OPTIONAL_HEADER32 pCoffHead,
					LPSTR lpszModuleName,
					DWORD dwBufSize
					){

	DWORD dwByte;
	DWORD dwExpTableBase = pCoffHead->DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress ; 
	DWORD dwExpTableSize = pCoffHead->DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].Size;
	IMAGE_EXPORT_DIRECTORY imgExpDir;

	lpszModuleName[0] = '\0';
	if(!hProcess) return FALSE;
	if(!dwExpTableBase) return FALSE;

	// GNX|[g fBNg e[u擾
	if(!ReadProcessMemory(hProcess,(LPVOID)(dwExpTableBase+dwImageBase),
		(LPVOID)&imgExpDir,sizeof(IMAGE_EXPORT_DIRECTORY),&dwByte)) return FALSE;

	// W[擾
	if(!ReadProcessMemory(hProcess,(LPVOID)(imgExpDir.Name+dwImageBase),
		(LPVOID)lpszModuleName,dwBufSize,&dwByte)) return FALSE;

	return TRUE;
}



//-----------------------------------------
// GNX|[ge[u̒֐
//
// dwMode = EXP_S_BREAKALL Ȃe[uɓo^Ă邷ׂĂ̊֐Ƀu[Nł
// Ȃ 1 AsȂ 0 Ԃ
//
// dwMode = EXP_S_FUNCTIONADDR Ȃ lpszTargetFunction 
// Ɏw肳ꂽ֐̃AhX(RVA:relative virtual address)Ԃ
// sAEAT(Export Address Table)   Forwarder RVA ̏ꍇ 0 ԂB
//
// dwMode = EXP_S_SHOWALLFUNCTION ȂGNX|[g邷ׂĂ̊֐ expout ɏo͂B

#define EXP_S_BREAKALL					0
#define EXP_S_FUNCTIONADDR				1
#define EXP_S_SHOWALLFUNCTION			2
#define EXP_S_SHOWALLFUNCTIONTOSTDOUT	3   // STDOUT ɕ\

DWORD SearchExpTable(HANDLE hProcess,
					DWORD dwImageBase,
					PIMAGE_OPTIONAL_HEADER32 pCoffHead,
					 LPSTR lpszTargetFunction,    
					 DWORD dwMode, 
					 BOOL bDebug){
	
	DWORD hint,dwByte,dwPreOutputMode;
	DWORD dwExpTableBase = pCoffHead->DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress ; 
	DWORD dwExpTableSize = pCoffHead->DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].Size;
	IMAGE_EXPORT_DIRECTORY imgExpDir;
	
	DWORD dwExpPointTableBase; // GNX|[g|C^e[uRVA(relative virtual address)
	DWORD dwNumberOfName;	   // O|C^ e[ũGg
	DWORD dwNumberOfFunctions;	// EAT ɓo^Ă֐̃Gg
	DWORD dwExpOrdTableBase;  // GNX|[ge[uRVA
	DWORD dwEATBase;		  // GNX|[g AhX e[uRVA
	DWORD dwAddr,dwFunctionAddr;
	WORD wIndex;
	char szModuleName[CHR_BUF];
	char szFunction[CHR_BUF];
	char szForwarder[CHR_BUF];
	
	if(!hProcess) return 0;
	if(!dwExpTableBase) return 0;
	
	// GNX|[g fBNg e[u擾
	if(!ReadProcessMemory(hProcess,(LPVOID)(dwExpTableBase+dwImageBase),
		(LPVOID)&imgExpDir,sizeof(IMAGE_EXPORT_DIRECTORY),&dwByte)) return 0;
	
	// W[擾
	if(!ReadProcessMemory(hProcess,(LPVOID)(imgExpDir.Name+dwImageBase),
		(LPVOID)szModuleName,CHR_BUF,&dwByte)) return 0;
	
	dwExpPointTableBase = imgExpDir.AddressOfNames;
	dwNumberOfName		= imgExpDir.NumberOfNames;
	dwExpOrdTableBase	= imgExpDir.AddressOfNameOrdinals;
	dwEATBase			= imgExpDir.AddressOfFunctions;
	dwNumberOfFunctions = imgExpDir.NumberOfFunctions;
	
	if(bDebug){
		OutputErrorMessage("\n---------------------------\n");
		OutputErrorMessage("Information of Export Table of %s\n",szModuleName);
		OutputErrorMessage("Export Name Pointer Table RVA: 0x%x\n",dwExpPointTableBase);
		OutputErrorMessage("Number of Names: %d\n",dwNumberOfName);
		OutputErrorMessage("Number of Functions: %d\n",dwNumberOfFunctions);
		OutputErrorMessage("Exp Ordinals Table RVA: 0x%x\n",dwExpOrdTableBase);
		OutputErrorMessage("Ordinal Base: %d\n",imgExpDir.Base);
		OutputErrorMessage("EAT Base: 0x%x\n",dwEATBase);
		OutputErrorMessage("---------------------------\n");
		if(dwMode == EXP_S_BREAKALL) OutputErrorMessage("ordinal  hint     RVA    name\n");
		else OutputErrorMessage("\n");
	}
	
	dwPreOutputMode = GetCurrentOutputMode();
	if(dwMode == EXP_S_SHOWALLFUNCTIONTOSTDOUT) SetOutputMode(ERRMODE_STDOUT,NULL);

	for(hint=0;hint<dwNumberOfFunctions;hint++){
		
		// hint ֐
		if(hint < dwNumberOfName){
			
			// Export Name Pointer Table T[`ĖO̒uĂAhX擾āc
			if(!ReadProcessMemory(
				hProcess,
				(LPVOID)(dwImageBase +dwExpPointTableBase +sizeof(DWORD)*hint),
				(LPVOID)&dwAddr,sizeof(DWORD),&dwByte)) return 0;
			
			// Export Name Table ֐擾
			if(!ReadProcessMemory(hProcess,(LPVOID)(dwImageBase + dwAddr),
				(LPVOID)szFunction,CHR_BUF,&dwByte)) return 0;

		}
		// Oꍇ
		else wsprintf(szFunction,"[%s : %d]",szModuleName,hint);
		
		if(dwMode != EXP_S_FUNCTIONADDR || !strcmp(szFunction,lpszTargetFunction)){
			
			// Export Ordinal Table  index 擾
			if(!ReadProcessMemory(hProcess,
				(LPVOID)(dwImageBase +dwExpOrdTableBase +sizeof(WORD)*hint),
				(LPVOID)&wIndex,sizeof(WORD),&dwByte)) return 0;
			
			// EAT ֐̃AhX擾
			// MSDN ɂ wIndex -= imgExpDir.Base ƏĂ邯ǊԈႢȂ̂ŒӁB
			if(!ReadProcessMemory(hProcess,
				(LPVOID)(dwImageBase+ dwEATBase +sizeof(DWORD)*wIndex),
				(LPVOID)&dwFunctionAddr,sizeof(DWORD),&dwByte)) return 0;
			
			// ֐̃AhXԂă^[
			if(dwMode == EXP_S_FUNCTIONADDR){
				if(dwExpTableBase <= dwFunctionAddr  // Forwarder RVA ̏ꍇ
					&& dwFunctionAddr <= dwExpTableBase+dwExpTableSize) dwFunctionAddr = 0;
				if(bDebug) OutputErrorMessage("%s = 0x%x\n",szFunction,dwFunctionAddr);
				return dwFunctionAddr;
			}

			// u[N̑ł
			else if(dwMode == EXP_S_BREAKALL){
				
				if(bDebug) 
					OutputErrorMessage("  %5d  %4d  %08x  %s",
					imgExpDir.Base+wIndex,hint,dwFunctionAddr,szFunction);
				
				if(!(dwExpTableBase <= dwFunctionAddr 
					&& dwFunctionAddr <= dwExpTableBase+dwExpTableSize)){ 
					
					// Export RVA Ȃu[Nł
					if(!PushBreakatSpecifiedAddr(hProcess,dwFunctionAddr+dwImageBase,
						MAX_ORG_CODE,szFunction,szModuleName,1)){
						OutputErrorMessage("function: %s\nmodule: %s\n\n",szFunction,szModuleName);
					}
					
				}
				//AhXGNX|[gZNVŖꍇ Forwarder RVA
				else if(bDebug) 
				{
					if(!ReadProcessMemory(hProcess,
						(LPVOID)(dwImageBase +dwFunctionAddr),
						(LPVOID)&szForwarder,CHR_BUF,&dwByte)) return 0;
					OutputErrorMessage("   -> %s",szForwarder);
				}
				
				if(bDebug) OutputErrorMessage("\n");
			}
			
			// ֐ƃAhX\
			else if(dwMode == EXP_S_SHOWALLFUNCTION || dwMode == EXP_S_SHOWALLFUNCTIONTOSTDOUT){

				if(!(dwExpTableBase <= dwFunctionAddr 
					&& dwFunctionAddr <= dwExpTableBase+dwExpTableSize))
					OutputErrorMessage("0x%8x  1  %s  %s\r\n",
					dwFunctionAddr+dwImageBase,szModuleName,szFunction);
			}

		}
	}
	
	SetOutputMode(dwPreOutputMode,NULL);

	if(dwMode != EXP_S_FUNCTIONADDR) return 1;
	return 0;
}



//-----------------------------------------
// GNX|[ge[u𒲂ׂĎw肵֐̃AhX𒲂ׂ֐
DWORD GetExpAddrOfAPI(HANDLE hProcess,
					  DWORD dwImageBase,
					PIMAGE_OPTIONAL_HEADER32 pCoffHead,
					 LPSTR lpszTargetFunction,    // AhX𒲂ׂ֐
					 BOOL bDebug){

	DWORD dwAddr = SearchExpTable(hProcess,dwImageBase,pCoffHead,lpszTargetFunction,EXP_S_FUNCTIONADDR,bDebug);
	if(dwAddr) dwAddr += dwImageBase;

	return  dwAddr;
}


//---------------------------------------------------
// GNX|[ge[uɓo^Ă邷ׂĂ̊֐Ƀu[Nł֐
BOOL SetBreakToAllFunction(HANDLE hProcess,
							DWORD dwImageBase,
							PIMAGE_OPTIONAL_HEADER32 pCoffHead,
							BOOL bDebug){

	return SearchExpTable(hProcess,dwImageBase,pCoffHead,"",EXP_S_BREAKALL,bDebug);
}


//-----------------------------------
// GNX|[ge[u𒲂ׂăGNX|[g֐o͂֐
BOOL ShowExportFunctions(HANDLE hProcess,
						 DWORD dwImageBase,
						  PIMAGE_OPTIONAL_HEADER32 pCoffHead){

	return SearchExpTable(hProcess,dwImageBase,pCoffHead,"",EXP_S_SHOWALLFUNCTION,TRUE);
}



//-----------------------------------
// GNX|[ge[u𒲂ׂăGNX|[g֐ stdout ɑSo͂֐
BOOL ShowExportFunctionsStdout(HANDLE hProcess,
						 DWORD dwImageBase,
						  PIMAGE_OPTIONAL_HEADER32 pCoffHead){

	return SearchExpTable(hProcess,dwImageBase,pCoffHead,"",EXP_S_SHOWALLFUNCTIONTOSTDOUT,TRUE);
}


// EOF