// fobO\֌W
//
// Copyright (c) 2001-2003 Tomoya Tokairin

#include "dbg.h"

HANDLE hError = GetStdHandle(STD_ERROR_HANDLE);
FILE* fErrFile = NULL;
DWORD DwOutputMode = ERRMODE_STDERR;
COORD DwCurPos;




DWORD cos_getwide()
{

    CONSOLE_SCREEN_BUFFER_INFO cinf;

	if(DwOutputMode != ERRMODE_DIALOG) return FALSE;

    GetConsoleScreenBufferInfo(hError,&cinf);

    return cinf.dwMaximumWindowSize.X;
}



DWORD cos_gethight()
{

    CONSOLE_SCREEN_BUFFER_INFO cinf;

	if(DwOutputMode != ERRMODE_DIALOG) return FALSE;

    GetConsoleScreenBufferInfo(hError,&cinf);

    return cinf.dwMaximumWindowSize.Y;
}



BOOL cos_cls()
{

    DWORD dwByte;
    COORD  coord;
    CONSOLE_SCREEN_BUFFER_INFO cinf;

	if(DwOutputMode != ERRMODE_DIALOG) return FALSE;

    GetConsoleScreenBufferInfo(hError,&cinf);
    coord.X = coord.Y = 0;
	FillConsoleOutputCharacter(hError,' ',cinf.dwSize.X * cinf.dwSize.Y, coord, &dwByte);
	cos_locate(0,0);

    return TRUE;;
}



BOOL cos_locate(SHORT x, SHORT y)
{
    DwCurPos.X = x;
    DwCurPos.Y = y;

	if(DwOutputMode != ERRMODE_DIALOG) return FALSE;

    if(!SetConsoleCursorPosition(hError,DwCurPos)) return FALSE;

	return TRUE;
}


//----------------------------------------
// o̓[h̐ݒ
BOOL SetOutputMode(DWORD dwMode,LPSTR lpszFile){

	switch(dwMode){

	case ERRMODE_FILE:
		if(fErrFile){
			DwOutputMode = ERRMODE_FILE;
			return TRUE;
		}
		if(lpszFile == NULL) return FALSE;
		if((fErrFile = fopen(lpszFile,"w")) == NULL) return FALSE;
		DwOutputMode = ERRMODE_FILE;
		break;


	case ERRMODE_DIALOG:
		DwOutputMode = ERRMODE_DIALOG;
		hError = GetStdHandle(STD_ERROR_HANDLE);
		break;


	case ERRMODE_STDERR:
		DwOutputMode = ERRMODE_STDERR;
		hError = GetStdHandle(STD_ERROR_HANDLE);
		break;

	default:
		DwOutputMode = ERRMODE_STDOUT;
		hError = GetStdHandle(STD_OUTPUT_HANDLE);
		break;
	}

	return TRUE;
}


//----------------------------------
// ݂̏o̓[h̎擾
DWORD GetCurrentOutputMode(){
	return DwOutputMode;
}
	



void CloseOutputMode(){
	if(fErrFile) fclose(fErrFile);
	CloseHandle(hError);
}


int OutputErrorMessage(LPSTR lpszFormat, ...){

	va_list vlist;
	char szOut[MAX_COMMANDLEN];
	DWORD dwByte;

	va_start(vlist,lpszFormat);
	vsprintf(szOut,lpszFormat,vlist);
	va_end(vlist);

	if(DwOutputMode == ERRMODE_DIALOG){
		if(DwCurPos.X){
			cos_locate(DwCurPos.X, DwCurPos.Y);
			DwCurPos.Y++;
		}
	}

	if(DwOutputMode == ERRMODE_FILE) fprintf(fErrFile,"%s",szOut);
	else WriteFile(hError,szOut,strlen(szOut),&dwByte,NULL);

	return dwByte;
}






//------------------------------------------------
// _v\֐  ߂l:o͂oCg
DWORD ShowDump(HANDLE hProcess,
			  DWORD dwAddr,
			  DWORD dwLeng
			  ){

	DWORD i,i2;
	const DWORD codesize = 16;
	DWORD dwByte,dwOut = 0;
	BYTE code[codesize];
	char szCode[codesize+1];
	memset(szCode,0,codesize+1);
	
	for(i=0;i<dwLeng;i+=codesize){
		
		OutputErrorMessage("0x%08x : ",dwAddr+i);

		if(!ReadProcessMemory(hProcess,(LPVOID)(dwAddr+i),(LPVOID)code,codesize,&dwByte)){
			for(i2 = 0;i2 < codesize;i2++) OutputErrorMessage("?? ");
			OutputErrorMessage(" : \n");
		}
		else{
			dwOut += dwByte;
			
			for(i2 = 0;i2 < codesize;i2++) OutputErrorMessage("%02x ",code[i2]);
			
			memcpy(szCode,code,codesize);
			for(i2=0;i2<codesize;i2++){
				if(szCode[i2] < 0x20 || 0x7e < szCode[i2]) szCode[i2] = '.'; 
			}
			OutputErrorMessage(" : %s\n",szCode);
		}
		
	}

	return dwOut;
}




//--------------------------------------------------
// DEBUG_EVENT ̏\
DWORD ReportDebugEvent(HANDLE hProcess,DEBUG_EVENT *lpDebugEvent,BOOL bShowMessage)
{
	DWORD dwRet = REPORT_CONTINUE;
	char szStr[CHR_BUF];
	DWORD dwByte;

	if(bShowMessage)
	{
		OutputErrorMessage("\n-Debug Event-\n");
		OutputErrorMessage("process: 0x%x\n",lpDebugEvent->dwProcessId);
		OutputErrorMessage("thread id: 0x%x\n",lpDebugEvent->dwThreadId);
	}
	
	switch(lpDebugEvent->dwDebugEventCode)
	{

	case	EXCEPTION_DEBUG_EVENT:
		if(bShowMessage) OutputErrorMessage("EXCEPTION_DEBUG_EVENT:\n");

		if(bShowMessage) OutputErrorMessage("code: ");
		switch(lpDebugEvent->u.Exception.ExceptionRecord.ExceptionCode)
		{

		case EXCEPTION_ACCESS_VIOLATION :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_ACCESS_VIOLATION \n");
			dwRet = REPORT_TERMINATE;
			break;

		case EXCEPTION_DATATYPE_MISALIGNMENT :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_DATATYPE_MISALIGNMENT \n");
			break;
	
		case EXCEPTION_BREAKPOINT :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_BREAKPOINT \n");
			break;
				
		case EXCEPTION_SINGLE_STEP :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_SINGLE_STEP \n");
			break;
			
		case EXCEPTION_ARRAY_BOUNDS_EXCEEDED: 
			if(bShowMessage) OutputErrorMessage("EXCEPTION_ARRAY_BOUNDS_EXCEEDED \n");
			break;
			
		case EXCEPTION_FLT_DENORMAL_OPERAND :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_FLT_DENORMAL_OPERAND \n");
			break;
			
		case EXCEPTION_FLT_DIVIDE_BY_ZERO :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_FLT_DIVIDE_BY_ZERO \n");
			break;
			
		case EXCEPTION_FLT_INEXACT_RESULT :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_FLT_INEXACT_RESULT \n");
			break;
			
		case EXCEPTION_FLT_INVALID_OPERATION :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_FLT_INVALID_OPERATION \n");
			break;
			
		case EXCEPTION_FLT_OVERFLOW :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_FLT_OVERFLOW \n");
			break;
			
		case EXCEPTION_FLT_STACK_CHECK :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_FLT_STACK_CHECK \n");
			break;
			
		case EXCEPTION_FLT_UNDERFLOW :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_FLT_UNDERFLOW \n");
			break;
		
		case EXCEPTION_INT_DIVIDE_BY_ZERO :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_INT_DIVIDE_BY_ZERO \n");
			break;
		
		case EXCEPTION_INT_OVERFLOW :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_INT_OVERFLOW \n");
			break;

		case EXCEPTION_PRIV_INSTRUCTION :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_PRIV_INSTRUCTION \n");
			break;
			
		case EXCEPTION_IN_PAGE_ERROR :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_IN_PAGE_ERROR \n");
			break;

		case EXCEPTION_ILLEGAL_INSTRUCTION :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_ILLEGAL_INSTRUCTION \n");
			break;
			
		case EXCEPTION_NONCONTINUABLE_EXCEPTION :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_NONCONTINUABLE_EXCEPTION \n");
			break;
			
		case EXCEPTION_STACK_OVERFLOW :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_STACK_OVERFLOW \n");
			break;

		case EXCEPTION_INVALID_DISPOSITION :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_INVALID_dwDisplOSITION \n");
			break;

		case EXCEPTION_GUARD_PAGE :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_GUARD_PAGE \n");
			break;

		case EXCEPTION_INVALID_HANDLE :
			if(bShowMessage) OutputErrorMessage("EXCEPTION_INVALID_HANDLE \n");
			break;

			// aplicatation defined exception
		default:
			if(bShowMessage) OutputErrorMessage("0x%x\n",lpDebugEvent->u.Exception.ExceptionRecord.ExceptionCode);
			dwRet = REPORT_NOTHANDLE;
			break;
		}

		if(bShowMessage) OutputErrorMessage("addr: 0x%x\n",lpDebugEvent->u.Exception.ExceptionRecord.ExceptionAddress);
		break;

	case	CREATE_THREAD_DEBUG_EVENT:
		if(bShowMessage) OutputErrorMessage("CREATE_THREAD_DEBUG_EVENT");
		if(bShowMessage) OutputErrorMessage(": handle = 0x%x\n",(DWORD)lpDebugEvent->u.CreateThread.hThread);
		break;

	case	CREATE_PROCESS_DEBUG_EVENT:

		if(bShowMessage) OutputErrorMessage("CREATE_PROCESS_DEBUG_EVENT");
		if(bShowMessage) OutputErrorMessage(": base = 0x%x",lpDebugEvent->u.CreateProcessInfo.lpBaseOfImage );
		break;

	case	EXIT_THREAD_DEBUG_EVENT:

		if(bShowMessage) OutputErrorMessage("EXIT_THREAD_DEBUG_EVENT");
		break;

	case	EXIT_PROCESS_DEBUG_EVENT: 

		if(bShowMessage) OutputErrorMessage("EXIT_PROCESS_DEBUG_EVENT");
		if(bShowMessage) OutputErrorMessage(": exit code = 0x%x",lpDebugEvent->u.ExitProcess.dwExitCode );
		break;

	case	LOAD_DLL_DEBUG_EVENT:

		if(bShowMessage) OutputErrorMessage("LOAD_DLL_DEBUG_EVENT");
		if(bShowMessage) OutputErrorMessage(": base = 0x%x",lpDebugEvent->u.LoadDll.lpBaseOfDll);
		break;

	case	UNLOAD_DLL_DEBUG_EVENT: 

		if(bShowMessage) OutputErrorMessage("UNLOAD_DLL_DEBUG_EVENT");
		break;

	case	OUTPUT_DEBUG_STRING_EVENT: 

		if(bShowMessage)
		{
			OutputErrorMessage("OUTPUT_DEBUG_STRING_EVENT\n");
			ReadProcessMemory(hProcess,lpDebugEvent->u.DebugString.lpDebugStringData,
				(LPVOID)szStr,lpDebugEvent->u.DebugString.nDebugStringLength,&dwByte);
			OutputErrorMessage(szStr);
		}
		
		break;

	case	RIP_EVENT:

		if(bShowMessage) OutputErrorMessage("RIP_EVENT");
		break;

	}

	if(bShowMessage) OutputErrorMessage("\n");

	return dwRet;
}




// EOF