#ifndef MYDEBUG_H
#define MYDEBUG_H

#define MAX_ORG_CODE	64	// ۑIWiR[h̃TCY

#define ERRMODE_STDERR		0
#define ERRMODE_FILE		1
#define ERRMODE_DIALOG		2
#define ERRMODE_STDOUT		3

#define REPORT_CONTINUE		0
#define REPORT_NOTHANDLE	1
#define REPORT_TERMINATE	2


//-------------------------
// dbg_mod.cpp

BOOL SetModuleInfo(HANDLE hProcess,DWORD dwAddr,LPSTR lpszModule);
void ShowModuleName();
BOOL CloseModuleInfo();
BOOL ShowAsmCode(DWORD dwAddr, DWORD dwAdmLine, LPSTR lpszCode);
BOOL GetModuleNameByAddr(DWORD dwAddr,LPSTR lpszModule);



//-------------------------
// dbg_break.cpp

BOOL PushBreakatSpecifiedAddr(HANDLE hProcess,DWORD dwAddr,DWORD dwOrgCodeLen,LPSTR lpszComment,LPSTR lpszComment2,DWORD dwObservNum);
BOOL RestoreBreakPoint(HANDLE hProcess,HANDLE hThread,DWORD dwEIP,LPDWORD lpdwBreakAddr,DWORD dwOrgCodeLen);
BOOL ExecStep(HANDLE hProcess,HANDLE hThread);
BOOL ExecUnStep(HANDLE hProcess,HANDLE hThread);
BOOL ReturnAPI(HANDLE hProcess,HANDLE hThread,WORD wCrearStackSize,BOOL bSetBreak,DWORD dwEAX);
DWORD SortBreakIndex(DWORD dwAddr);
BOOL EmbedBreak(HANDLE hProcess,DWORD dwAddr);
DWORD CountUpAddr(DWORD dwAddr,LPDWORD lpdwObservNum);
BOOL ShowTotalBreakInfo();
BOOL ClearBreakInfo();
BOOL CancelBreakPoint(HANDLE hProcess,HANDLE hThread,DWORD dwAddr);
BOOL ReadBreakSettingFile(HANDLE hProcess,LPSTR lpszBreakFile,BOOL bDebug);
BOOL SaveBreakSettingFile(LPSTR lpszBreakFile,BOOL bDebug);
void ShowBreakInfo(DWORD dwAddr,HANDLE hThread);



//-------------------------
// dbg_coff.cpp 

BOOL GetCoffHead(LPSTR szExeName,BOOL bFile,LPSTR lpszModuleName,HANDLE hProcess,DWORD dwImageBase,PIMAGE_OPTIONAL_HEADER32 pCoffHead,BOOL bDebug);
BOOL ShowImportFunctions(HANDLE hProcess,DWORD dwImageBase,PIMAGE_OPTIONAL_HEADER32 pCoffHead);
DWORD GetImpAddrOfAPI(HANDLE hProcess,DWORD dwImageBase,PIMAGE_OPTIONAL_HEADER32 pCoffHead,LPSTR lpszTargetFunction,BOOL bDebug);
BOOL ShowExportFunctions(HANDLE hProcess,DWORD dwImageBase,PIMAGE_OPTIONAL_HEADER32 pCoffHead);
BOOL ShowExportFunctionsStdout(HANDLE hProcess,DWORD dwImageBase,PIMAGE_OPTIONAL_HEADER32 pCoffHead);
DWORD GetExpAddrOfAPI(HANDLE hProcess,DWORD dwImageBase,PIMAGE_OPTIONAL_HEADER32 pCoffHead,LPSTR lpszTargetFunction,BOOL bDebug);
BOOL GetModuleName(HANDLE hProcess,DWORD dwImageBase,PIMAGE_OPTIONAL_HEADER32 pCoffHead,LPSTR lpszModuleName,DWORD dwBufSize);
BOOL SetBreakToAllFunction(HANDLE hProcess,DWORD dwImageBase,PIMAGE_OPTIONAL_HEADER32 pCoffHead,BOOL bDebug);


//-------------------------
// dbg_trace.cpp 

BOOL TraceInit(HANDLE hProcess);
BOOL LoadSymbolTable(HANDLE hProcess,LPSTR lpszModuleName);
BOOL TraceStackFrame(HANDLE hProcess,HANDLE hThread,DWORD dwSize);
BOOL TraceClose(HANDLE hProcess);



//-------------------------
// dbg_show.cpp

DWORD ShowDump(HANDLE hProcess,DWORD dwAddr,DWORD dwLeng);
BOOL SetOutputMode(DWORD dwMode,LPSTR lpszFile);
DWORD GetCurrentOutputMode();
int OutputErrorMessage(LPSTR lpszFormat, ...);
void CloseOutputMode();
BOOL cos_cls();
BOOL cos_locate(SHORT x, SHORT y);
DWORD cos_getwide();
DWORD cos_gethight();
DWORD ReportDebugEvent(HANDLE hProcess,DEBUG_EVENT *lpDebugEvent,BOOL bShowMessage);
//-------------------------
//dbg_calc.cpp
BOOL CalcOperand(HANDLE hThread,LPSTR lpszForm,LPDWORD lpdwOut);
BOOL GetOperand(DWORD dwEIP,char szOperand[][256]);


//-------------------------
// ̑

DWORD GetDWORD(HANDLE hProcess,DWORD dwAddr);
DWORD ReadDebugStack(HANDLE hProccess,HANDLE hThread,LPVOID lpStackDat,DWORD dwLength);
DWORD ReadDebugMem(HANDLE hProccess,HANDLE hThread,DWORD dwAddr,LPVOID lpDat,DWORD dwLength);
DWORD GetCurrentEIP(HANDLE hThread);
DWORD GetCurrentESP(HANDLE hThread);
DWORD GetCurrentEAX(HANDLE hThread);
BOOL ShowReg(HANDLE hThread,DWORD dwESP);


#endif