// I/O ֌W
//  Copyright (c) 2001-2003 Tomoya Tokairin

#include "common.h"
#include "debug.h"
#include "io.h"


// mmioOpenA ̃p[^
typedef struct
{
	DWORD dwReturnAddr;
	DWORD szFilename; 
	LPMMIOINFO lpmmioinfo;  
	DWORD dwOpenFlags;  
}MMIOOPENAPARAM,*LPMMIOOPENAPARAM;


// mmioSeek ̃p[^
typedef struct
{
	DWORD dwReturnAddr;
	DWORD hmmio;
	DWORD lOffset; 
	int iOrigin; 
}MMIOSEEKPARAM,*LPMMIOSEEKPARAM;


// mmioRead ̃p[^
typedef struct
{
	DWORD dwReturnAddr;
	DWORD hmmio;
	DWORD pch;    
	DWORD cch;     
}MMIOREADPARAM,*LPMMIOREADPARAM;



// mmioClose ̃p[^
typedef struct
{
	DWORD dwReturnAddr;
	DWORD hmmio; 
	UINT wFlags;  
}MMIOCLOSEPARAM,*LPMMIOCLOSEPARAM;


//--------------------------------
// t@Cnhf[^x[Xւ̓o^
BOOL RegistFileDataBase(DWORD dwOpenFileHandle,
						LPTHREADINFO lpThInfo,
						LPFILETABLE lpFileTable,
						LPBUFFINFO lpBufferInfo,
						DWORD dwDebugLevel
						){

	DWORD i;

	// Ƀf[^x[XɂȂ`FbN
	for(i=0;i<lpFileTable->dwStreamNum;i++)
	{
		if(lpFileTable->hStream[i] == dwOpenFileHandle) return FALSE;
	}
	
	// t@Cf[^x[XɃnhǉ
	strcpy(lpFileTable->hStreamFileName[lpFileTable->dwStreamNum],lpThInfo->szFileName);
	lpFileTable->hStream[lpFileTable->dwStreamNum] = dwOpenFileHandle;
	if(dwDebugLevel) OutputErrorMessage("file: %s\n",lpThInfo->szFileName);
	
	// ^[Qbg̃t@C`FbN
	if(strcmp(lpFileTable->szTargetFile,lpThInfo->szFileName) == 0)
	{
		for(i=0;i<MAX_READFILE;i++)	if(lpFileTable->dwTargetStream[i] == MAX_OPENHANDLE-1) break;
		lpFileTable->dwTargetStream[i] = lpFileTable->dwStreamNum;

		// obt@̃Jgʒu擪ɖ߂ (obt@̃TCYƂ͖̓)
		lpBufferInfo->dwCurPos[i] = lpBufferInfo->dwTopPos;
//		lpBufferInfo->dwNumberOfRead = 0;

		if(dwDebugLevel)
		{
			OutputErrorMessage("!! This is the Target File !!\ntarget id= %d\n",i);
		}

	}
	
	lpFileTable->dwStreamNum++;

	return TRUE;
}



//------------------------------------------------
//  CreateFile  1
BOOL Event_CreateFile(HANDLE hProcess,
					  HANDLE hThread,
					  LPTHREADINFO lpThInfo,
					  BOOL bWide, // Chgǂ
					  BOOL bMMIO,
					  DWORD dwDebugLevel
					  ){
	
	MMIOOPENAPARAM mmioParam;

	DWORD dwByte;
	DWORD dwFoo;
	WCHAR wszFile[MAX_PATH];
	char szFile[MAX_PATH],szExt[MAX_PATH];

	// X^bN擾
	if(bMMIO){
		// mmioOpen gp
		memcpy(&mmioParam,&lpThInfo->defaultParam,sizeof(MMIOOPENAPARAM));
		lpThInfo->openParam.dwReturnAddr = mmioParam.dwReturnAddr;
		lpThInfo->openParam.lpFileName = mmioParam.szFilename;
		lpThInfo->openParam.dwAccess = GENERIC_READ;
		if(mmioParam.dwOpenFlags & MMIO_WRITE) lpThInfo->openParam.dwAccess = GENERIC_WRITE;
		else if(mmioParam.dwOpenFlags & MMIO_READWRITE ) lpThInfo->openParam.dwAccess |= GENERIC_WRITE;
		lpThInfo->openParam.dwShareMode = FILE_SHARE_READ | FILE_SHARE_WRITE;
	}
	else {
		// CreateFile gp
		memcpy(&lpThInfo->openParam,&lpThInfo->defaultParam,sizeof(CREATEFILEWPARAM));
	}
	
	// I[vt@C擾
	if(bWide){ // CreateFileW
		ReadProcessMemory(hProcess,(LPVOID)lpThInfo->openParam.lpFileName,wszFile,MAX_PATH,&dwByte);
		dwByte = WideCharToMultiByte(CP_ACP,0,wszFile,-1,NULL,0,NULL,NULL);
		WideCharToMultiByte(CP_ACP,0,wszFile,-1,lpThInfo->szFilePathName,dwByte,NULL,NULL);
	} // CreateFile
	else ReadProcessMemory(hProcess,(LPVOID)lpThInfo->openParam.lpFileName,lpThInfo->szFilePathName,MAX_PATH,&dwByte);

	// t@Co
	_splitpath(lpThInfo->szFilePathName,NULL,NULL,szFile,szExt);	
	wsprintf(lpThInfo->szFileName,"%s%s",szFile,szExt);
	
	if(dwDebugLevel){
		OutputErrorMessage("****************** OPEN_EVENT ******************\n");
		OutputErrorMessage("file = %s\n",lpThInfo->szFileName);
		dwFoo = lpThInfo->openParam.dwAccess;
		if(dwFoo == 0) OutputErrorMessage("QUERY DEVICE\n");
		if(dwFoo & GENERIC_READ) OutputErrorMessage("GENERIC_READ\n");
		if(dwFoo & GENERIC_WRITE) OutputErrorMessage("GENERIC_WRITE\n");
		dwFoo = lpThInfo->openParam.dwShareMode;
		if(dwFoo & FILE_SHARE_DELETE) OutputErrorMessage("FILE_SHARE_DELETE\n");
		if(dwFoo & FILE_SHARE_READ) OutputErrorMessage("FILE_SHARE_READ\n");
		if(dwFoo & FILE_SHARE_WRITE) OutputErrorMessage("FILE_SHARE_WRITE\n");
	}
	
	// CreateFile ̏o break ł
	if(lpThInfo->openParam.dwAccess & GENERIC_READ){
		
		lpThInfo->dwOpenRetAddrW = lpThInfo->openParam.dwReturnAddr;

		if(!PushBreakatSpecifiedAddr(
			hProcess,
			lpThInfo->dwOpenRetAddrW,
			MAX_ORG_CODE,
			"Return Addr of CreateFile","",1)) return FALSE;
		
	}

	// XebvsZbg
	ExecStep(hProcess,hThread);

	return TRUE;
}



//------------------------------------------------
//  CreateFile  2
// CreadteFile ̏õu[N|Cg̏
BOOL Event_CreateFile2(HANDLE hProcess,
					  HANDLE hThread,
					  LPTHREADINFO lpThInfo,
					  LPFILETABLE lpFileTable,
					  LPBUFFINFO lpBufferInfo,
					  DWORD dwDebugLevel
					  ){
	
	DWORD dwOpenFileHandle;
	
	// t@Cnh擾
	if(!(dwOpenFileHandle = GetCurrentEAX(hThread)))
	{
		OutputErrorMessage("CreateFile failed!\n");
	}
	
	if(dwDebugLevel)
	{
		OutputErrorMessage("****************** OPEN_EVENT_2 ******************\n");
		OutputErrorMessage("handle = 0x%x\n",dwOpenFileHandle);
	}
	
	lpThInfo->dwOpenRetAddrW = 0;
	
	RegistFileDataBase(dwOpenFileHandle,lpThInfo,lpFileTable,lpBufferInfo,dwDebugLevel);

	return TRUE;
}


//------------------------------------------------
//  CloseHandle
BOOL Event_CloseHandle(HANDLE hProcess,
					   HANDLE hThread,
					   LPTHREADINFO lpThInfo,
					   LPFILETABLE lpFileTable,
					   DWORD dwDebugLevel
					   )
{
	DWORD i,i2;
	
	// X^bN擾
	memcpy(&lpThInfo->closeParam,&lpThInfo->defaultParam,sizeof(CLOSEHANDLEPARAM));

	if(dwDebugLevel)
	{
		OutputErrorMessage("****************** CLOSE_EVENT ******************\n");
		OutputErrorMessage("handle = 0x%x\n",lpThInfo->closeParam.hFileHandle);
	}

	// Xg[̃f[^x[X
	if(lpThInfo->closeParam.hFileHandle != NULL)
	{
		for(i=0;i<MAX_OPENHANDLE;i++)
		{
			if(lpFileTable->hStream[i] == lpThInfo->closeParam.hFileHandle)
			{
				lpFileTable->hStream[i] = NULL;
				if(dwDebugLevel) 
				{
					OutputErrorMessage("%s : closed\n",lpFileTable->hStreamFileName[i]);
				}

				break;
			}
		}
		
		// ̂̓^[Qbg?
		for(i2=0;i2<MAX_READFILE;i2++)
		{
			if(lpFileTable->dwTargetStream[i2] == i)
			{
				lpFileTable->dwTargetStream[i2] = MAX_OPENHANDLE-1;
				if(dwDebugLevel) 
				{
					OutputErrorMessage("This was the target file\n");
				}

				break;
			}
		}
	}
	
	// XebvsZbg
	ExecStep(hProcess,hThread);
	
	return TRUE;
}


//-----------------------------
// SetFilePointer
BOOL Event_SetFilePointer(HANDLE hProcess,
					   HANDLE hThread,
					   LPTHREADINFO lpThInfo,
					   LPFILETABLE lpFileTable,
					   LPBUFFINFO lpBufferInfo,
					   BOOL bMMIO,
					   DWORD dwDebugLevel
					   )
{
	MMIOSEEKPARAM mmioParam;
	
	static DWORD dwSetHandleCount = 0;
	DWORD dwSetHandleNum = 1;
	DWORD i,dwTargetNum;

	// X^bN擾
	if(bMMIO)
	{ // mmioSeek gp
		memcpy(&mmioParam,&lpThInfo->defaultParam,sizeof(MMIOSEEKPARAM));
		lpThInfo->seekParam.dwReturnAddr = mmioParam.dwReturnAddr;
		lpThInfo->seekParam.hFileHandle = mmioParam.hmmio;
		lpThInfo->seekParam.dwSeekPoint = mmioParam.lOffset;
		lpThInfo->seekParam.lpDistanceToMoveHigh = 0;
		if(mmioParam.iOrigin == SEEK_CUR) lpThInfo->seekParam.dwMoveMethod = FILE_CURRENT;
		else if(mmioParam.iOrigin == SEEK_END ) lpThInfo->seekParam.dwMoveMethod = FILE_END;
		else if(mmioParam.iOrigin == SEEK_SET ) lpThInfo->seekParam.dwMoveMethod = FILE_BEGIN;
	}
	else
	{ // SetFilePointer gp
		memcpy(&lpThInfo->seekParam,&lpThInfo->defaultParam,sizeof(SETFILEPOINTERPARAM));
	}

	if(dwDebugLevel)
	{
		OutputErrorMessage("****************** SEEK_EVENT ******************\n");
		OutputErrorMessage("handle = 0x%x move = %d movehigh = 0x%x method = %d\n",
			lpThInfo->seekParam.hFileHandle,lpThInfo->seekParam.dwSeekPoint,lpThInfo->seekParam.lpDistanceToMoveHigh,lpThInfo->seekParam.dwMoveMethod);
		switch(lpThInfo->seekParam.dwMoveMethod){
		case FILE_BEGIN: OutputErrorMessage("FILE_BEGIN\n");break;
		case FILE_CURRENT: OutputErrorMessage("FILE_CURRENT\n");break;
		case FILE_END: OutputErrorMessage("FILE_END\n");break;
		}
	}
	
	for(dwTargetNum=0;dwTargetNum<MAX_READFILE;dwTargetNum++)
	{
		if(
			lpFileTable->dwTargetStream[dwTargetNum] != MAX_OPENHANDLE-1
			&&
			lpThInfo->seekParam.hFileHandle 
			== lpFileTable->hStream[lpFileTable->dwTargetStream[dwTargetNum]]) break;
	}

	// ^[Qbg̃Xg[Ŗ炻̂܂܏𑱂
	if(dwTargetNum >= MAX_READFILE)
	{
		// IWiR[h
		// ReturnAPI() ŉoCgR[ĥ
		// MAX_ORG_CODE ߂B

		// main.cpp  case EXCEPTION_BREAKPOINT:
		// ̏Ŋ eip ͖߂Ă̂
		// ł dwEIP = 0 w肷
		if(!RestoreBreakPoint(
			hProcess,
			hThread,
			0,
			&lpThInfo->dwSingleStepAddr,
			MAX_ORG_CODE
			)) return FALSE;	
		
		ExecStep(hProcess,hThread);
		
		return TRUE;
	}

	if(lpThInfo->seekParam.dwMoveMethod == FILE_END)
	{
		OutputErrorMessage("Can't use FILE_END.\n");
		return FALSE;
	}
	
	if(lpThInfo->seekParam.dwMoveMethod == FILE_CURRENT){
		lpThInfo->seekParam.dwSeekPoint = 
			GETCURADDR(lpBufferInfo->dwBufTailAddr,lpBufferInfo->dwBufSize,lpBufferInfo->dwCurPos[dwTargetNum],lpBufferInfo->dwBotPos)
			+ lpThInfo->seekParam.dwSeekPoint;
	}
	
	if(dwDebugLevel)
		OutputErrorMessage("before: top = 0x%x cur = 0x%x bot = 0x%x addr = 0x%x \n",
		lpBufferInfo->dwTopPos,lpBufferInfo->dwCurPos[dwTargetNum],lpBufferInfo->dwBotPos,lpBufferInfo->dwBufTailAddr);
	
	if((LONG)lpThInfo->seekParam.dwSeekPoint <= 0) lpBufferInfo->dwCurPos[dwTargetNum] = lpBufferInfo->dwTopPos;
	else if(lpThInfo->seekParam.dwSeekPoint < lpBufferInfo->dwBufTailAddr){
		
		// obt@̒̃AhXɃV[Nꍇ
		DWORD dwBackSize,dwTopToBotSize;
		
		// Ō牽oCgڂ̂Ƃɖ߂邩vZ
		dwBackSize = lpBufferInfo->dwBufTailAddr - lpThInfo->seekParam.dwSeekPoint;
		
		// obt@Ƀf[^cĂ邩`FbN
		dwTopToBotSize = lpBufferInfo->dwTopPos > lpBufferInfo->dwBotPos ?
			lpBufferInfo->dwBufSize : lpBufferInfo->dwBotPos - lpBufferInfo->dwTopPos +1;
		if(dwBackSize > dwTopToBotSize){
			OutputErrorMessage("fail to seek the lpBufferInfo->\n");
			dwBackSize = dwTopToBotSize;
		}
		
		lpBufferInfo->dwCurPos[dwTargetNum] 
			= (lpBufferInfo->dwBotPos - dwBackSize) & (lpBufferInfo->dwBufSize -1);
	}
	else if(lpThInfo->seekParam.dwSeekPoint > lpBufferInfo->dwBufTailAddr){
		
		// obt@̍Ōɔԏꍇ
		DWORD dwForwdSize;
		
		// ǂݍݗʌvZ
		dwForwdSize = lpThInfo->seekParam.dwSeekPoint - lpBufferInfo->dwBufTailAddr;
		if(dwDebugLevel) OutputErrorMessage("forward: %d byte\n",dwForwdSize);
		
		if(dwForwdSize > lpBufferInfo->dwBufSize){
			OutputErrorMessage("Can't seek the lpBufferInfo->\n");
			return FALSE;
		}
		
		lpBufferInfo->dwCurPos[dwTargetNum] = lpBufferInfo->dwBotPos;
		ReadDataFromStdin(lpBufferInfo,dwForwdSize,dwTargetNum,dwDebugLevel);
		lpBufferInfo->dwCurPos[dwTargetNum] = lpBufferInfo->dwBotPos;
		
	}
	
	i = GETCURADDR(lpBufferInfo->dwBufTailAddr,lpBufferInfo->dwBufSize,lpBufferInfo->dwCurPos[dwTargetNum],lpBufferInfo->dwBotPos);
	
	if(dwDebugLevel) OutputErrorMessage(
		"after : top = 0x%x cur = 0x%x bot = 0x%x addr = 0x%x\nreturn %d\n",
		lpBufferInfo->dwTopPos,lpBufferInfo->dwCurPos[dwTargetNum],lpBufferInfo->dwBotPos,lpBufferInfo->dwBufTailAddr
		,i);


	// ̂܂܃^[
	if(bMMIO)
		ReturnAPI(hProcess,hThread,sizeof(MMIOSEEKPARAM)-sizeof(DWORD),TRUE,i);
	else
		ReturnAPI(hProcess,hThread,sizeof(SETFILEPOINTERPARAM)-sizeof(DWORD),TRUE,i);
	
	return TRUE;
}




//-----------------------------
// ReadFile
BOOL Event_ReadFile(HANDLE hProcess,
					   HANDLE hThread,
					   LPTHREADINFO lpThInfo,
					   LPFILETABLE lpFileTable,
					   LPBUFFINFO lpBufferInfo,
					   BOOL bVerbose,
					   BOOL bMMIO,
					   DWORD dwDebugLevel
					   )
{
	MMIOREADPARAM mmioParam;

	DWORD dwWriteSize,dwTargetNum;

	// X^bN擾
	// X^bN擾
	if(bMMIO)
	{
		// mmioRead gp
		memcpy(&mmioParam,&lpThInfo->defaultParam,sizeof(MMIOREADPARAM));
		lpThInfo->readParam.dwReturnAddr = mmioParam.dwReturnAddr;
		lpThInfo->readParam.hFileHandle = mmioParam.hmmio;
		lpThInfo->readParam.lpBuf = mmioParam.pch;
		lpThInfo->readParam.dwLeng = mmioParam.cch;
		lpThInfo->readParam.lpdwLeng = 0;
		lpThInfo->readParam.lpOverlapped = 0;
	}
	else 
	{ // ReadFile gp
		memcpy(&lpThInfo->readParam,&lpThInfo->defaultParam,sizeof(READFILEPARAM));
	}
	
	if(dwDebugLevel) 
	{
		OutputErrorMessage("****************** READ_EVENT ******************\n");
		OutputErrorMessage("handle = 0x%x  buf = 0x%x  n = %d  lpn = 0x%x ovl = 0x%x\n",
			lpThInfo->readParam.hFileHandle,lpThInfo->readParam.lpBuf,
			lpThInfo->readParam.dwLeng,
			lpThInfo->readParam.lpdwLeng,
			lpThInfo->readParam.lpOverlapped);
	}

	for(dwTargetNum=0;dwTargetNum<MAX_READFILE;dwTargetNum++)
	{
		if(
			lpFileTable->dwTargetStream[dwTargetNum] != MAX_OPENHANDLE-1
			&&
			lpThInfo->readParam.hFileHandle 
			== lpFileTable->hStream[lpFileTable->dwTargetStream[dwTargetNum]]) break;
	}	

	// ^[Qbg̃Xg[Ŗ炻̂܂ܕʂ̏s
	if(dwTargetNum >= MAX_READFILE)
	{
		if(dwDebugLevel) OutputErrorMessage("This is not target file\n");

		// IWiR[h
		// ReturnAPI() ŉoCgR[ĥ
		// MAX_ORG_CODE ߂B
		if(!RestoreBreakPoint(hProcess,hThread,0,&lpThInfo->dwSingleStepAddr,MAX_ORG_CODE)) return FALSE;
		ExecStep(hProcess,hThread);
		return TRUE;
	}

	// uJnĂ邩
	if(++(lpBufferInfo->dwNumberOfRead) <= lpBufferInfo->dwStart)
	{
		if(!RestoreBreakPoint(hProcess,hThread,0,&lpThInfo->dwSingleStepAddr,MAX_ORG_CODE)) return FALSE;
		ExecStep(hProcess,hThread);
		return TRUE;
	}
	
	// stdin obt@ɑȂ̃f[^ǂݍ
	ReadDataFromStdin(lpBufferInfo,lpThInfo->readParam.dwLeng,dwTargetNum,dwDebugLevel);
	
	// qvZX̃Ƀf[^
	dwWriteSize = WriteDataToChildProcess(hProcess, 
		hThread,lpBufferInfo,
		lpThInfo,
		dwTargetNum,
		bVerbose,
		dwDebugLevel);
	
	// ̂܂܃^[
	if(bMMIO) 
		ReturnAPI(hProcess,hThread,sizeof(MMIOREADPARAM)-sizeof(DWORD),TRUE,dwWriteSize);
	else
		ReturnAPI(hProcess,hThread,sizeof(READFILEPARAM)-sizeof(DWORD),TRUE,TRUE);

	return TRUE;
}



//-----------------------------
// GetFileSize
BOOL Event_GetFileSize(HANDLE hProcess,
					   HANDLE hThread,
					   LPTHREADINFO lpThInfo,
					   LPFILETABLE lpFileTable,
					   LPBUFFINFO lpBufferInfo,
					   BOOL bMMIO,
					   DWORD dwDebugLevel
					   )
{
	static DWORD dwSetHandleCount = 0;
	DWORD dwSetHandleNum = 1;
	DWORD dwTargetNum,dwByte;
	
	// X^bN擾
	memcpy(&lpThInfo->getsizeParam,&lpThInfo->defaultParam,sizeof(GETFILESIZEPARAM));

	if(dwDebugLevel)
	{
		OutputErrorMessage("****************** GETFILESIZE_EVENT ******************\n");
		OutputErrorMessage("handle = 0x%x lpFileSizeHigh = 0x%x\n",
			lpThInfo->getsizeParam.hFileHandle,lpThInfo->getsizeParam.lpFileSizeHigh);
	}
	
	for(dwTargetNum=0;dwTargetNum<MAX_READFILE;dwTargetNum++)
	{
		if(
			lpFileTable->dwTargetStream[dwTargetNum] != MAX_OPENHANDLE-1
			&&
			lpThInfo->getsizeParam.hFileHandle 
			== lpFileTable->hStream[lpFileTable->dwTargetStream[dwTargetNum]]) break;
	}

	// ^[Qbg̃Xg[ŖAzt@CTCY=0 ̎͂̂܂܏𑱂
	if(dwTargetNum >= MAX_READFILE || lpThInfo->liFileSize.QuadPart == 0)
	{
		// IWiR[h
		// ReturnAPI() ŉoCgR[ĥ
		// MAX_ORG_CODE ߂B

		// main.cpp  case EXCEPTION_BREAKPOINT:
		// ̏Ŋ eip ͖߂Ă̂
		// ł dwEIP = 0 w肷
		if(!RestoreBreakPoint(
			hProcess,
			hThread,
			0,
			&lpThInfo->dwSingleStepAddr,
			MAX_ORG_CODE
			)) return FALSE;	
		
		ExecStep(hProcess,hThread);
		
		return TRUE;
	}
	
	// qvZX̃Ƀf[^
	if(lpThInfo->getsizeParam.lpFileSizeHigh != NULL)
	{
		if(!WriteProcessMemory(hProcess,(LPVOID)lpThInfo->getsizeParam.lpFileSizeHigh,
			&(lpThInfo->liFileSize.HighPart),sizeof(LARGE_INTEGER),&dwByte))
		{
			OutputErrorMessage("could't WriteProcessMemory\n");
			return FALSE;
		}
	}
	
	if(dwDebugLevel) OutputErrorMessage(
		"size = %I64u(0x%I64x)\n",lpThInfo->liFileSize,lpThInfo->liFileSize);
	
	// ̂܂܃^[
	ReturnAPI(hProcess,hThread,sizeof(GETFILESIZEPARAM)-sizeof(DWORD),TRUE,lpThInfo->liFileSize.LowPart);
	
	return TRUE;
}
				

//-------------------------------------
// \

void DrawHorLine(short y){
	
	DWORD i;

	if(GetCurrentOutputMode() == ERRMODE_DIALOG){
		cos_locate(0,y);
		for(i=0;i<cos_getwide()-1;i++) OutputErrorMessage("-");
		OutputErrorMessage("\n");
	}
	else OutputErrorMessage("\n");
	
}

void DrawVarLine(short x,short y,DWORD dwHeight){
	
	DWORD i;
	
	if(GetCurrentOutputMode() == ERRMODE_DIALOG){
		cos_locate(x,y);
		for(i=0;i<=dwHeight;i++) OutputErrorMessage("|\n");
		cos_locate(x+2,y);
	}

}


BOOL ShowInformation(HANDLE hProcess,
					   HANDLE hThread,
					   LPTHREADINFO lpThInfo,
					   DWORD dwEIP,
					   DWORD dwESP,
					   DWORD dwDump,
					   char szOperand[][CHR_BUF],
					   DWORD dwShowWindow
					   ){
	
	DWORD i,i2;
	short locateY = 0;
	const DWORD datasize = 16;
	DWORD dwCurMode = GetCurrentOutputMode();
	char szData[datasize+1];
	memset(szData,0,datasize+1);

	if(dwCurMode == ERRMODE_DIALOG) cos_cls();
//	else OutputErrorMessage("\n");
	
	// \
	if(dwShowWindow & DIAG_SHOWINFO){	
		ShowBreakInfo(dwEIP,hThread);
		
		if(dwCurMode != ERRMODE_DIALOG)
			OutputErrorMessage("return addr: 0x%08x\n",lpThInfo->defaultParam.dwReturnAddr);

		locateY += LOCATE_INFO_HT +1;
	}
	
	// call stack ̃g[X\
	if(dwShowWindow & DIAG_SHOWCALLSTACK){
		if(dwShowWindow & DIAG_SHOWINFO) locateY -= (LOCATE_INFO_HT +1);
		DrawVarLine(LOCATE_CALLSTACK_X,locateY,LOCATE_INFO_HT);
		if(GetCurrentOutputMode() != ERRMODE_DIALOG)
			OutputErrorMessage("\ncall stack:\n");
		TraceStackFrame(hProcess,hThread,LOCATE_INFO_HT);
		locateY += (LOCATE_INFO_HT+1);
	}
	
	// X^bN\
	if(dwShowWindow & DIAG_SHOWSTACK){
		DrawHorLine(locateY);
		OutputErrorMessage("stack(esp = 0x%08x):\n",dwESP);
		locateY += (short)ShowDump(hProcess,dwESP,sizeof(DEFAULTFUNCPARAM))/16+2;
	}
	
	// X^bNڍ׏
	if(dwShowWindow & DIAG_SHOWSTACK2){
		DrawHorLine(locateY);
		for(i=0;i<sizeof(DEFAULTFUNCPARAM);i+=sizeof(DWORD)){
			memcpy(&i2,(LPBYTE)&lpThInfo->defaultParam + i,sizeof(DWORD));
			OutputErrorMessage("0x%08x : ",dwESP+i);
			ShowDump(hProcess,i2,datasize);
		}
		locateY += sizeof(DEFAULTFUNCPARAM)/sizeof(DWORD)+1;
	}

	// _v
	if(dwShowWindow & DIAG_SHOWMEM){
		DrawHorLine(locateY);
		ShowDump(hProcess,dwDump,LOCATE_MEM_HT*16);
		locateY += LOCATE_MEM_HT+1;
	}
	
	// R[h\
	if(dwShowWindow & DIAG_SHOWCODE){
		DrawHorLine(locateY);
		ShowAsmCode(dwEIP,LOCATE_CODE_HT,NULL);
		locateY += LOCATE_CODE_HT+1;
	}

	// WX^\
	if(dwShowWindow & DIAG_SHOWREG){
		if(dwShowWindow & DIAG_SHOWCODE) locateY -= LOCATE_CODE_HT;
		else DrawHorLine(locateY++);
		DrawVarLine(LOCATE_REG_X,locateY,LOCATE_CODE_HT);
		if(GetCurrentOutputMode() != ERRMODE_DIALOG)
			OutputErrorMessage("\nreg:\n");
		ShowReg(hThread,dwEIP);
		if(dwShowWindow & DIAG_SHOWCODE) locateY += LOCATE_CODE_HT;
		else locateY += LOCATE_CODE_HT+1;
	}

	// ϐEHb`\
	if(dwShowWindow & DIAG_SHOWVARWATCH){
		DrawHorLine(locateY);
		
		for(i=0;i<4;i++){
			if(strlen(szOperand[i])){
				if(CalcOperand(hThread,szOperand[i],&i2)){
					OutputErrorMessage("%s = 0x%08x (%d)\n    ",szOperand[i],i2,i2);
					ShowDump(hProcess,i2,16);
				}
				else OutputErrorMessage("\n\n");
			}
			else OutputErrorMessage("\n\n");
		}

		locateY += LOCATE_VARWATCH_HT+1;
	}	

	if(dwCurMode == ERRMODE_DIALOG){
		DrawHorLine(locateY);
	}
	
	return TRUE;
}


//----------------------------------------
// Θb[h
BOOL DialogMode(HANDLE hProcess,
				HANDLE hThread,	
				LPTHREADINFO lpThInfo,
				DWORD dwEIP,
				DWORD dwESP,
				char szOperand[][CHR_BUF], // ݂̍s̃Iyh
				LPDIAGDATA lpdiagData,
				LPBOOL lpStepMode
){

	DWORD i;
	char szDiagCom[CHR_BUF],szTemp[CHR_BUF];
	LPDWORD lpdwShowWindow = &lpdiagData->dwShowWindow;
	LPDWORD lpdwDumpAddr = &lpdiagData->dwDumpAddr;
	DWORD dwCode,dwByte;
//	static DWORD dwShowWindow = DIAG_SHOWINFO| DIAG_SHOWSTACK| DIAG_SHOWMEM|DIAG_SHOWCODE| DIAG_SHOWCALLSTACK| DIAG_SHOWREG| DIAG_SHOWVARWATCH;
//	static DWORD dwDumpAddr = 0;

	// u[N|Cgݒp
	DWORD dwAddr;
	DWORD dwObservNum;
	char szComment1[CHR_BUF];
	char szComment2[CHR_BUF];


	ShowInformation(hProcess,hThread,lpThInfo,dwEIP,dwESP,*lpdwDumpAddr,szOperand,*lpdwShowWindow);
	
	for(;;){
		fflush(stdin);
		OutputErrorMessage("\n");
		if(*lpStepMode) OutputErrorMessage("[step mode] ");
		OutputErrorMessage("command (? for help) > ");
		gets(szDiagCom);
		i = 0; while(szDiagCom[i] == ' ') i++; 
		memmove(szDiagCom,szDiagCom+i,CHR_BUF-i);
	
		switch(szDiagCom[0]){

		case '?':
			OutputErrorMessage("0x[addr]: dump memory\n");
			OutputErrorMessage("r(redraw),c(show code),s(step mode),q(quit)\n");
			OutputErrorMessage("b(break),d(delete break),w(calc),W(write code)\n");
			OutputErrorMessage("1,2,3,4,5: show/hide windows\n");
			break;
			
		case '1': i = DIAG_SHOWSTACK; goto L_VIEW;
		case '2': i = DIAG_SHOWMEM; goto L_VIEW;
		case '3': i = DIAG_SHOWSTACK2; goto L_VIEW;
		case '4': i = DIAG_SHOWCODE | DIAG_SHOWREG; goto L_VIEW;
		case '5': i = DIAG_SHOWVARWATCH; goto L_VIEW;

L_VIEW: 
			*lpdwShowWindow = (*lpdwShowWindow & (~i)) + ((~*lpdwShowWindow) & i);
		case 'r': // ĕ`
			ShowInformation(hProcess,hThread,lpThInfo,dwEIP,dwESP,*lpdwDumpAddr,szOperand,*lpdwShowWindow);
			break;
			
		case 'q':
			TerminateProcess(hProcess,1);
			Sleep(100);
			return FALSE;
			
		case 'd': // u[N|Cg폜
			CancelBreakPoint(hProcess,hThread,dwEIP);
			goto L_EXITDIALOG;

		case 'b': // u[N|CgZbg
			OutputErrorMessage("addr [cancel: enter] > ");
			fgets(szTemp,CHR_BUF,stdin);
			if(strlen(szTemp) == 0 || (strlen(szTemp) == 1 && szTemp[0] == 10)) break;

			sscanf(szTemp,"%x",&dwAddr);
			OutputErrorMessage("skip [default: 1]> ");
			fgets(szTemp,CHR_BUF,stdin);
			if(szTemp[0] == '\n') dwObservNum = 1;
			else sscanf(szTemp,"%x",&dwObservNum);
			OutputErrorMessage("comment1 > ");
			fgets(szTemp,CHR_BUF,stdin);
			memset(szComment1,0,CHR_BUF);
			sscanf(szTemp,"%s",szComment1); // \r\n 
			OutputErrorMessage("comment2 > ");
			fgets(szTemp,CHR_BUF,stdin);
			memset(szComment2,0,CHR_BUF);
			sscanf(szTemp,"%s",szComment2);
	
			if(PushBreakatSpecifiedAddr(hProcess,dwAddr,
				MAX_ORG_CODE,szComment1,szComment2,dwObservNum))
				OutputErrorMessage("Set break at 0x%x Skip = %d\n\n",dwAddr,dwObservNum);

			break;


		case 'c': // R[h
			OutputErrorMessage("addr > ");
			fgets(szDiagCom,CHR_BUF,stdin);
			sscanf(szDiagCom,"%x",&i);
			ShowAsmCode(i,cos_gethight()-3,NULL);
			break;
			
		case '0':  // 
			sscanf(szDiagCom,"%x",lpdwDumpAddr);
			ShowDump(hProcess,*lpdwDumpAddr,MEM_DUMPSIZE);
			break;

		case 'w': // ϐvZ
			OutputErrorMessage("> ");
			fgets(szTemp,CHR_BUF,stdin);
			if(CalcOperand(hThread,szTemp,&i)){
				OutputErrorMessage("0x%08x (%d)\n",i,i);
				ShowDump(hProcess,i,16);
			}
			break;

		case 's':  // Xebvs
			*lpStepMode = !(*lpStepMode);
			break;


		case 'W': // 
			OutputErrorMessage("start addr [cancel: enter] > ");
			fgets(szTemp,CHR_BUF,stdin);
			if(strlen(szTemp) == 0 || (strlen(szTemp) == 1 && szTemp[0] == 10)) break;
			sscanf(szTemp,"%x",&dwAddr);
			for(;;)
			{
				dwCode = 0;
				if(!ReadProcessMemory(hProcess,(LPVOID)dwAddr,(LPVOID)&dwCode,1,&dwByte))
				{
					OutputErrorMessage("Error: can't ReadProcessMemory at 0x%x\n",dwAddr);
					break;
				}
				OutputErrorMessage("[quit: q] 0x%x : 0x%x -> ",dwAddr,dwCode);
				fgets(szTemp,CHR_BUF,stdin);
				if(szTemp[0] == 'q') break;
				sscanf(szTemp,"%x",&dwCode);
				if(!WriteProcessMemory(hProcess,(LPVOID)dwAddr,(LPVOID)&dwCode,1,&dwByte)) return FALSE;
				FlushInstructionCache(hProcess,(LPVOID)dwAddr,1);
				dwAddr++;
			}

			break;

		case NULL:
			OutputErrorMessage("continue...\n");
			goto L_EXITDIALOG;
			
		default:
			break;

		}
	}

L_EXITDIALOG:

	return TRUE;
}

				




//-------------------------------------------
// DLL ̃[h̏֐
BOOL LoadDllEvent(HANDLE hProcess,
					  DWORD dwImageBase,
					  DWORD dwDebugLevel
					  ){
	
	IMAGE_OPTIONAL_HEADER32 coffHead;
	CHAR szModuleName[CHR_BUF];

	SetModuleInfo(hProcess,dwImageBase,NULL);
	
	if(dwDebugLevel){
		OutputErrorMessage("\n****************** LOAD_DLL ******************\n");
		
		if(dwDebugLevel >= 2){
			// W[\
			if(!GetCoffHead("",FALSE,szModuleName,hProcess,dwImageBase,&coffHead,dwDebugLevel)) 
				return FALSE;
			
			if(dwDebugLevel >= 3){
				
				// GNX|[g֐\
				ShowExportFunctions(hProcess,dwImageBase,&coffHead);
				
				// V{e[u[h
				if(dwDebugLevel >= 4) LoadSymbolTable(hProcess,szModuleName);	
			}
		}
	}

	return TRUE;
}



//-------------------------------------
// stdin  EOF ǂ
BOOL BoolEOF = FALSE;
BOOL FeofStdin(){return BoolEOF;}


//-------------------------------------
// stdin w肳ꂽTCỸf[^ǂݍފ֐
DWORD ReadFromStdin(LPBYTE lpBuf,DWORD dwReadByte,BOOL bDebug){

	HANDLE hIn = GetStdHandle(STD_INPUT_HANDLE);
	DWORD dwTotalReadByte = 0;
	DWORD dwRemainByte = dwReadByte;
	DWORD dwByte;
	
	while(1){
		ReadFile(hIn,lpBuf+dwTotalReadByte,
			dwRemainByte,
			&dwByte,NULL);
		if(!dwByte) 
		{
			BoolEOF = TRUE;
			break;
		}
		dwTotalReadByte += dwByte;
		dwRemainByte -= dwByte;
		if(!dwRemainByte) break;
	}

	if(bDebug) OutputErrorMessage("read from stdin: %d byte\n",dwTotalReadByte); 

	return dwTotalReadByte;
}




//-------------------------------------------------------------
// stdin obt@ɑȂ̃f[^ǂݍ
void ReadDataFromStdin(LPBUFFINFO lpBuffer,
					   DWORD dwLeng,  // ǂݍݗ
					   DWORD dwTarget,
					   BOOL bDebug
					   )
{
	DWORD dwRemainByte,dwReadByte,dwTotalReadSize;

	if(!dwLeng) return;
				
	// obt@̒ɎcĂf[^TCYvZ
	dwRemainByte = lpBuffer->dwBufSize * (lpBuffer->dwCurPos[dwTarget] > lpBuffer->dwBotPos) 
		+ lpBuffer->dwBotPos - lpBuffer->dwCurPos[dwTarget];
	
	// f[^Ȃꍇ stdin f[^ǂݍ
	if(dwRemainByte < dwLeng){
		
		// stdin ̓ǂݍ݃TCYvZ
		dwTotalReadSize = dwLeng - dwRemainByte;
		
		// ǂݍ
		while(1){
			
			dwReadByte = lpBuffer->dwBufSize - lpBuffer->dwBotPos < dwTotalReadSize ?
				lpBuffer->dwBufSize - lpBuffer->dwBotPos : dwTotalReadSize ;
			
			dwReadByte = 
				ReadFromStdin(
				lpBuffer->lpBuffer + lpBuffer->dwBotPos,
				dwReadByte,
				bDebug);
			
			lpBuffer->dwBotPos = (lpBuffer->dwBotPos + dwReadByte) & (lpBuffer->dwBufSize-1);
			lpBuffer->dwBufTailAddr += dwReadByte;
			dwTotalReadSize -= dwReadByte;
			
			if(lpBuffer->dwBufTailAddr >= lpBuffer->dwBufSize && 
				lpBuffer->dwBotPos >= lpBuffer->dwTopPos)  
				lpBuffer->dwTopPos = (lpBuffer->dwBotPos + 1) & (lpBuffer->dwBufSize -1);
			
			if(dwTotalReadSize == 0 || dwReadByte == 0) break;
			
		}
	}
	
	if(bDebug) OutputErrorMessage("buffer info: target id = %d top = 0x%x cur = 0x%x bot = 0x%x addr = 0x%x\n",
		dwTarget,lpBuffer->dwTopPos,lpBuffer->dwCurPos[dwTarget],lpBuffer->dwBotPos,lpBuffer->dwBufTailAddr);
	
}



//------------------------------------------------
// Read CxgɎqvZX̃Ƀf[^ފ֐
// lpszDat == "" ̎ EOF ɂȂ
DWORD WriteChildMem(HANDLE hChild,
				   LPTHREADINFO lpThInfo,
				   LPVOID lpWriteBuffer,
				   DWORD dwWriteByte,
				   DWORD dwTotalByte
				   ){
	
	DWORD dwByte;
	
	if(lpThInfo->readParam.lpdwLeng)
	{
		if(!WriteProcessMemory(hChild,(LPVOID)lpThInfo->readParam.lpdwLeng,(LPVOID)&dwTotalByte,
			sizeof(DWORD),&dwByte))
		{
			OutputErrorMessage("WriteChildMem: Can't WriteProcessMemory [lpdwLeng]\n");
			return 0;
		}
	}

	dwByte = dwWriteByte;
	if(dwWriteByte)
	{
		if(!WriteProcessMemory(hChild,(LPVOID)lpThInfo->readParam.lpBuf,lpWriteBuffer,dwWriteByte,&dwByte))
		{
			OutputErrorMessage("WriteChildMem: Can't WriteProcessMemory [lpBuf]\n");
			return 0;
		}
	}

	return dwByte;
}




//-------------------------------------------------------------
// f[^qvZX̃Ԃɏފ֐
DWORD WriteDataToChildProcess(HANDLE hProccess, 
							 HANDLE hThread,
							 LPBUFFINFO lpBuffer,
							 LPTHREADINFO lpThInfo,
							 DWORD dwTargetNum,
							 BOOL bVerbose,
							 BOOL bDebug
							 )
{
	DWORD dwRemainByte,dwWroteSize;
	DWORD dwTotalWriteSize,dwTotalWriteSize2,dwWriteByte;
				
	// ݃TCYvZ
	dwRemainByte = lpBuffer->dwBufSize * (lpBuffer->dwCurPos[dwTargetNum] > lpBuffer->dwBotPos) 
		+ lpBuffer->dwBotPos - lpBuffer->dwCurPos[dwTargetNum];
	
	dwTotalWriteSize = dwRemainByte >= lpThInfo->readParam.dwLeng ? lpThInfo->readParam.dwLeng : dwRemainByte;
	dwTotalWriteSize2 = dwTotalWriteSize;
	if(bDebug) OutputErrorMessage("total write size = %d byte\n",dwTotalWriteSize);
	dwWroteSize = 0;

	// qvZX̃obt@Ƀf[^
	while(1)
	{
		dwWriteByte = lpBuffer->dwBufSize - lpBuffer->dwCurPos[dwTargetNum] < dwTotalWriteSize ?
			lpBuffer->dwBufSize - lpBuffer->dwCurPos[dwTargetNum] : dwTotalWriteSize ;
		
		dwWroteSize += WriteChildMem(
			hProccess,
			lpThInfo,
			lpBuffer->lpBuffer +  lpBuffer->dwCurPos[dwTargetNum],
			dwWriteByte,
			dwTotalWriteSize2);
		
		if(bDebug) OutputErrorMessage("write to child process = %d byte (wrote = %d byte)\n",dwWriteByte,dwWroteSize);
		lpBuffer->dwCurPos[dwTargetNum] = (lpBuffer->dwCurPos[dwTargetNum] + dwWriteByte) & (lpBuffer->dwBufSize -1);
		dwTotalWriteSize -= dwWriteByte;
		lpThInfo->readParam.lpBuf += dwWriteByte;
		
		if(dwTotalWriteSize == 0) break;
	}
	
	if(bDebug) OutputErrorMessage("buffer info: top = 0x%x cur = 0x%x bot = 0x%x addr = 0x%x\n",
		lpBuffer->dwTopPos,lpBuffer->dwCurPos[dwTargetNum],lpBuffer->dwBotPos,lpBuffer->dwBufTailAddr);
	if(bDebug) OutputErrorMessage("wrote size = %d byte\n",dwWroteSize);
	
	if(bVerbose) OutputErrorMessage("\015%d k",lpBuffer->dwBufTailAddr/1024);

	return dwWroteSize;
}


//EOF